%
%  system of first order linear ODEs
%  homogeneous
%  reactor problem
%
clear all;
close all;
% input 
k12 = 0.50; 
k21 = 0.25; 
k13 = 0.20; 
k31 = 0.05; 
k23 = 0.30; 
k32 = 0.15; 
A = [ (-k13-k12), k21, k31; k12, (-k21-k23), k32; k13, k23, (-k31-k32)]; 
yo = [1.0/3.0; 1.0/3.0; 1.0/3.0]; 
to = 0.0; 
tf = 20.0; 
n = max(size(A)); 
% compute eigenvalues and eigenvectors 
[wcol,lambdac] = eig(A)
detwcol = det(wcol)
wcolinv = inv(wcol); 
% set up discretized solution grid 
npoints = 1000; 
dt = (tf-to)/npoints; 
for i = 1:1:npoints+1 
 tp(i) = (i-1)*dt +to; 
end 
% calculate solution 
explambda = zeros(n,n); 
yp = zeros(n,npoints+1); 
for i = 1:1:npoints+1 
 for j = 1:n 
 explambda(j,j) = exp(lambdac(j,j)*(tp(i) - to) ); 
 end 
 yp(:,i) = wcol*explambda*wcolinv*yo; 
end 
%plot 
for j = 1:1:n 
 if (j==1) 
 plot (tp,yp(j,:),'g-'), xlabel( 't' ), ylabel ( 'y' ) 
 elseif (j==2) 
 plot (tp,yp(j,:),'r-'), xlabel( 't' ), ylabel ( 'y' ) 
 elseif (j==3) 
 plot (tp,yp(j,:),'b-'), xlabel( 't' ), ylabel ( 'y' ) 
 end 
 hold on 
end 
legend('1','2','3')
hold off
