function [x,y]=heunn_short(n,xo,xf,yo);
dx = (xf-xo)/n;
x = zeros(n+1,1);
for i = 1:1:n+1
   x(i) = xo + (i-1)*dx;
end
m=max(size(yo));
y = zeros(n+1,m);
y(1,1:m) = yo(1:m);
dydx = zeros(1,m);
ytemp = zeros(1,m);
k1 = zeros(1,m);
k2 = zeros(1,m);
for i =  1:1:n
   x1 = x(i);
   ytemp(1:m) = y(i,1:m);
   k1(1:m) = funkeval(x1,ytemp);
   x2 = x(i) + dx;
   ytemp(1:m) = y(i,1:m) + dx*k1(1:m);
   k2(1:m) = funkeval(x2,ytemp);
   dydx(1:m) = 1.0/2.0*(k1(1:m) + k2(1:m));
   y(i+1,1:m) = y(i,1:m) + dx*dydx(1:m);
end
close all;
iplot = 1;
if (iplot == 1)
   for i = 1:1:m
      color_index = get_plot_color(i);
      plot (x(:),y(:,i),color_index); 
      hold on;
   end
   hold off;
   xlabel( 'x' ); 
   ylabel ( 'y' );
   legend (int2str([1:m]'));
end
fid = fopen('heunn_out.txt','w');
fprintf(fid,'x  y(1) ... y(m) \n');
for i = 1:1:n+1
   fprintf(fid,'%23.15e ', x(i));
   for j = 1:1:m
      fprintf(fid,'%23.15e ', y(i,j));
   end
   fprintf(fid,' \n');
end
fclose(fid);

function dydx = funkeval(x,y);
dydx(1) = -1.0*y(1) - 2.0*y(2) - 0.5*y(3)^2;
dydx(2) = -0.1*y(1) - 4.0*y(2) - 0.5*y(3);
dydx(3) = -0.5*y(1) - 0.4*y(2) - 0.2*y(3);







%
% this little function sets colors for curves in plot
%
function color_index = get_plot_color(i);
if (i == 1) 
   color_index = 'k-';
elseif (i == 2)
   color_index = 'r-';
elseif (i == 3)
   color_index = 'b-';
elseif (i == 4)
   color_index = 'g-';
elseif (i == 5)
   color_index = 'm-';
elseif (i == 6) 
   color_index = 'k:';
elseif (i == 7)
   color_index = 'r:';
elseif (i == 8)
   color_index = 'b:';
elseif (i == 9)
   color_index = 'g:';
elseif (i == 10)
   color_index = 'm:';
else
   color_index = 'k-';
end