function [x,y]=linode_2o_seq_n_short(n,xo,xf,yo);
dx = (xf-xo)/n;
x = zeros(n+1,1);
for i = 1:1:n+1
   x(i) = xo + (i-1)*dx;
end
m=max(size(yo));
y = zeros(n+1,m);
y(1,1:m) = yo(1:m);
for k =  2:1:n+1
   AA = zeros(m,m);
   BB = zeros(m,1);
   for i = 1:1:m
      BB(i) = 0.5*dx*(funkeval_b(i,x(k)) + funkeval_b(i,x(k-1)));
      for j = 1:1:m
         AA(i,j) = funkeval_c(i,j,x(k))   - 0.50*dx*funkeval_a(i,j,x(k));
		 term =    funkeval_c(i,j,x(k-1)) + 0.50*dx*funkeval_a(i,j,x(k-1));
		 BB(i) = BB(i) + term*y(k-1,j);
      end
   end
   invAA = inv(AA);
   y(k,1:m) = invAA*BB;
end
close all;
iplot = 1;
if (iplot == 1)
   for i = 1:1:m
      color_index = get_plot_color(i);
      plot (x(:),y(:,i),color_index); 
      hold on;
   end
   hold off;
   xlabel( 'x' ); 
   ylabel ( 'y' );
   legend (int2str([1:m]'));
end
fid = fopen('linode_2o_seq_n_out.txt','w');
fprintf(fid,'x  y(1) ... y(m) \n');
for i = 1:1:n+1
   fprintf(fid,'%23.15e ', x(i));
   for j = 1:1:m
      fprintf(fid,'%23.15e ', y(i,j));
   end
   fprintf(fid,' \n');
end
fclose(fid);

%  c(x)*dy_/dx = A(x)*y_ + b(x);
function aout = funkeval_a(i,j,x);
amat = [0 1; -1 -1];
aout = amat(i,j);

function bout = funkeval_b(i,x);
bvec = [1/(1+x); 0];
bout = bvec(i);

function cout = funkeval_c(i,j,x);
cmat = [1 0; 0 1];
cout = cmat(i,j);







%
% this little function sets colors for curves in plot
%
function color_index = get_plot_color(i);
if (i == 1) 
   color_index = 'k-';
elseif (i == 2)
   color_index = 'r-';
elseif (i == 3)
   color_index = 'b-';
elseif (i == 4)
   color_index = 'g-';
elseif (i == 5)
   color_index = 'm-';
elseif (i == 6) 
   color_index = 'k:';
elseif (i == 7)
   color_index = 'r:';
elseif (i == 8)
   color_index = 'b:';
elseif (i == 9)
   color_index = 'g:';
elseif (i == 10)
   color_index = 'm:';
else
   color_index = 'k-';
end